pre-commit:
  parallel: true
  commands:
    test: &test
      skip: true
      files: git diff --name-only --diff-filter=d --staged
      glob: "*.{go,mod,sum}"
      run: make test
    golangci_lint: &golangci_lint
      skip: true
      tags: lint
      files: git diff --name-only --diff-filter=d --staged
      glob: "*.go"
      run: if command -v golangci-lint 2> /dev/null; then golangci-lint run; else echo "golangci-lint is not found. Install golangci-lint"; fi
    secrets-detection:
      tags: secrets
      files: git diff --name-only --diff-filter=d --staged
      run: 'if command -v gitleaks > /dev/null 2>&1; then gitleaks protect --no-banner --staged --redact --verbose; else echo "WARNING: gitleaks is not installed. Please install it. See https://github.com/zricethezav/gitleaks#installing."; fi'
    shadow: &shadow
      skip: true
      tags: lint
      files: git diff --name-only --diff-filter=d --staged
      glob: "*.go"
      run: 'if command -v shadow 2> /dev/null; then shadow ./...; else echo "shadow is not found. Please install it: go install golang.org/x/tools/go/analysis/passes/shadow/cmd/shadow@latest"; fi'
pre-push:
  parallel: true
  commands:
    test:
      <<: *test
      skip: false
      files: git diff --name-only --diff-filter=d $(git merge-base origin/main HEAD)..HEAD
    golangci_lint:
      <<: *golangci_lint
      skip: false
      files: git diff --name-only --diff-filter=d $(git merge-base origin/main HEAD)..HEAD
    shadow:
      <<: *shadow
      skip: false
      files: git diff --name-only --diff-filter=d $(git merge-base origin/main HEAD)..HEAD

